<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>src.app &#8212; pandas 2.1.1 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=841abef3"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for src.app</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">click</span>
<span class="kn">import</span> <span class="nn">logging</span>


<span class="c1"># logging.getLogger().setLevel(logging.DEBUG)</span>


<span class="nd">@click</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="n">chain</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="k">def</span> <span class="nf">cli</span><span class="p">():</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Pandas DataFrame CLI manipulation.</span>
<span class="sd">    </span>
<span class="sd">    This CLI allows users to read, write, and manipulate pandas DataFrames</span>
<span class="sd">    from the command line.</span>
<span class="sd">    &quot;&quot;&quot;</span>

<span class="c1"># ---------------------------------------------------------------------------</span>
<span class="c1"># Allow multiple chainning cmd see : https://click.palletsprojects.com/en/7.x/commands/#multi-command-pipelines</span>
<span class="c1"># and https://github.com/pallets/click/tree/master/examples/imagepipe</span>
<span class="c1"># credits: https://github.com/pallets</span>

<div class="viewcode-block" id="process_commands">
<a class="viewcode-back" href="../../api/src.html#src.app.process_commands">[docs]</a>
<span class="nd">@cli</span><span class="o">.</span><span class="n">result_callback</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">process_commands</span><span class="p">(</span><span class="n">processors</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This result callback is invoked with an iterable of all the chained</span>
<span class="sd">    subcommands.  Each subcommand returns a function that is chained together</span>
<span class="sd">    to feed one into the other, similar to how a pipe on unix works.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Start with an empty iterable.</span>
    <span class="n">stream</span> <span class="o">=</span> <span class="p">()</span>

    <span class="c1"># Pipe it through all stream processors.</span>
    <span class="k">for</span> <span class="n">processor</span> <span class="ow">in</span> <span class="n">processors</span><span class="p">:</span>
        <span class="n">stream</span> <span class="o">=</span> <span class="n">processor</span><span class="p">(</span><span class="n">stream</span><span class="p">)</span>

    <span class="c1"># Evaluate the stream and throw away the items.</span>
    <span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="n">stream</span><span class="p">:</span>
        <span class="k">pass</span></div>



<span class="c1"># Commands are added in other modules</span>
<span class="kn">from</span> <span class="nn">.dataframe</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">index</span><span class="p">,</span> <span class="n">columns</span><span class="p">,</span> <span class="n">dtypes</span><span class="p">,</span> <span class="n">info</span><span class="p">,</span> <span class="n">axes</span><span class="p">,</span> <span class="n">size</span><span class="p">,</span> <span class="n">shape</span><span class="p">,</span> <span class="n">memory_usage</span><span class="p">,</span> <span class="n">empty</span><span class="p">,</span>
    <span class="n">tabular</span><span class="p">,</span> <span class="n">astype</span><span class="p">,</span> <span class="n">convert_dtypes</span><span class="p">,</span> <span class="n">infer_objects</span><span class="p">,</span> <span class="n">head</span><span class="p">,</span> <span class="n">idxmax</span><span class="p">,</span> <span class="n">idxmin</span><span class="p">,</span>
    <span class="n">tail</span><span class="p">,</span> <span class="n">xs</span><span class="p">,</span> <span class="n">get</span><span class="p">,</span> <span class="n">query</span><span class="p">,</span> <span class="n">agg</span><span class="p">,</span> <span class="n">groupby</span><span class="p">,</span> <span class="n">corr</span><span class="p">,</span> <span class="n">describe</span><span class="p">,</span> <span class="nb">eval</span><span class="p">,</span> <span class="n">reduce</span><span class="p">,</span> <span class="n">drop</span><span class="p">,</span>
    <span class="n">stack</span><span class="p">,</span> <span class="n">unstack</span><span class="p">,</span> <span class="n">transpose</span><span class="p">,</span> <span class="n">sort_index</span><span class="p">,</span> <span class="n">sort</span><span class="p">,</span> <span class="n">rename</span><span class="p">,</span> <span class="n">reset_index</span>
<span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">index</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">columns</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">dtypes</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">info</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">axes</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">size</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">shape</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;memory-usage&quot;</span><span class="p">)(</span><span class="n">memory_usage</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">empty</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">tabular</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">astype</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;convert-dtypes&quot;</span><span class="p">)(</span><span class="n">convert_dtypes</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;infer-objects&quot;</span><span class="p">)(</span><span class="n">infer_objects</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">head</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">idxmax</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">idxmin</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">tail</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">xs</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">get</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">query</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">agg</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">groupby</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">corr</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">describe</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="nb">eval</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">reduce</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">drop</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">stack</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">unstack</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">transpose</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;sort-index&quot;</span><span class="p">)(</span><span class="n">sort_index</span><span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">sort</span><span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">rename</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;reset-index&quot;</span><span class="p">)(</span><span class="n">reset_index</span><span class="p">)</span> <span class="c1"># tested</span>

<span class="kn">from</span> <span class="nn">.inout</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">read</span><span class="p">,</span> <span class="n">write</span>
<span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">read</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">write</span><span class="p">)</span> <span class="c1"># tested</span>

<span class="kn">from</span> <span class="nn">.general</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">melt</span><span class="p">,</span> <span class="n">pivot</span><span class="p">,</span> <span class="n">merge</span><span class="p">,</span> <span class="n">join</span><span class="p">,</span> <span class="n">concat</span>
<span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">melt</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">pivot</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">merge</span><span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">join</span><span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">concat</span><span class="p">)</span> <span class="c1"># tested</span>
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">pandas</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../pandas.html">Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Branden Kappes.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>